require 'date'

module Display
  class Calendar
    def initialize
    end

    def calendar(month,year)
      firstday  = get_firstday(month,year)
      lastday   = get_lastday(month,year)
      wday      = firstday.wday

      result = ""
      result << put_month(month,year)
      result << "\n"
      result << put_wday
      result << "\n"
      result << "   " * wday
      firstday.day.upto(lastday.day) do |d|
        result << sprintf("%2d ", d.to_s)
        wday += 1
        if wday == 7
          result << "\n"
          wday = 0
        end
      end
      result << "\n"
      return result
    end


    private
    def get_firstday(month,year)
      return Date.new(year,month,1)
    end

    def get_lastday(month,year)
      return Date.new(year,month,-1)
    end

    def put_month(month,year)
      return Date.new(year,month,1).strftime("%B %Y").center(20)
    end

    def put_wday
      return 'Su Mo Tu We Th Fr Sa'
    end

  end
end
